gi-atk-2.0.28: Atk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | Safe-Inferred
Language | Haskell2010

GI.Atk.Interfaces.Action

Contents

- Exported types
- Methods
  - doAction
  - getDescription
  - getKeybinding
  - getLocalizedName
  - getNActions
  - getName
  - setDescription

Description

The ATK interface provided by UI components which the user can activate/interact with.

`Action` should be implemented by instances of `Object` classes with which the user can interact directly, i.e. buttons, checkboxes, scrollbars, e.g. components which are not "passive" providers of UI information.

Exceptions: when the user interaction is already covered by another appropriate interface such as `EditableText` (insert/delete text, etc.) or `Value` (set value) then these actions should not be exposed by `Action` as well.

Though most UI interactions on components should be invocable via keyboard as well as mouse, there will generally be a close mapping between "mouse actions" that are possible on a component and the AtkActions. Where mouse and keyboard actions are redundant in effect, `Action` should expose only one action rather than exposing redundant actions if possible. By convention we have been using "mouse centric" terminology for `Action` names.

Synopsis

- newtype Action = Action (ManagedPtr Action)
- class (ManagedPtrNewtype o, IsDescendantOf Action o) => IsAction o
- actionDoAction :: (HasCallStack, MonadIO m, IsAction a) => a -> Int32 -> m Bool
- actionGetDescription :: (HasCallStack, MonadIO m, IsAction a) => a -> Int32 -> m (Maybe Text)
- actionGetKeybinding :: (HasCallStack, MonadIO m, IsAction a) => a -> Int32 -> m (Maybe Text)
- actionGetLocalizedName :: (HasCallStack, MonadIO m, IsAction a) => a -> Int32 -> m (Maybe Text)
- actionGetNActions :: (HasCallStack, MonadIO m, IsAction a) => a -> m Int32
- actionGetName :: (HasCallStack, MonadIO m, IsAction a) => a -> Int32 -> m (Maybe Text)
- actionSetDescription :: (HasCallStack, MonadIO m, IsAction a) => a -> Int32 -> Text -> m Bool

# Exported types

newtype Action Source #

Memory-managed wrapper type.

Constructors

Action (ManagedPtr Action) |

#### Instances

Instances details

Eq Action Source # |
Instance details Defined in GI.Atk.Interfaces.Action Methods (==) :: Action -> Action -> Bool Source # (/=) :: Action -> Action -> Bool Source #
BoxedPtr Action Source # |
Instance details Defined in GI.Atk.Interfaces.Action Methods boxedPtrCopy :: Action -> IO Action Source # boxedPtrFree :: Action -> IO () Source #
ManagedPtrNewtype Action Source # |
Instance details Defined in GI.Atk.Interfaces.Action Methods toManagedPtr :: Action -> ManagedPtr Action Source #

class (ManagedPtrNewtype o, IsDescendantOf Action o) => IsAction o Source #

Type class for types which implement `Action`.

#### Instances

Instances details

(ManagedPtrNewtype o, IsDescendantOf Action o) => IsAction o Source # |
Instance details Defined in GI.Atk.Interfaces.Action

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

doAction.

#### Getters

getDescription, getKeybinding, getLocalizedName, getNActions, getName.

#### Setters

setDescription.

## doAction

actionDoAction Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Object` instance that implements AtkActionIface
-> Int32 | `i`: the action index corresponding to the action to be performed
-> m Bool | Returns: `True` if success, `False` otherwise

Perform the specified action on the object.

## getDescription

actionGetDescription Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Object` instance that implements AtkActionIface
-> Int32 | `i`: the action index corresponding to the action to be performed
-> m (Maybe Text) | Returns: a description string, or `Nothing` if `action` does not implement this interface.

Returns a description of the specified action of the object.

## getKeybinding

actionGetKeybinding Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Object` instance that implements AtkActionIface
-> Int32 | `i`: the action index corresponding to the action to be performed
-> m (Maybe Text) | Returns: the keybinding which can be used to activate this action, or `Nothing` if there is no keybinding for this action.

Gets the keybinding which can be used to activate this action, if one exists. The string returned should contain localized, human-readable, key sequences as they would appear when displayed on screen. It must be in the format "mnemonic;sequence;shortcut".

- The mnemonic key activates the object if it is presently enabled onscreen. This typically corresponds to the underlined letter within the widget. Example: "n" in a traditional "New..." menu item or the "a" in "Apply" for a button.
- The sequence is the full list of keys which invoke the action even if the relevant element is not currently shown on screen. For instance, for a menu item the sequence is the keybindings used to open the parent menus before invoking. The sequence string is colon-delimited. Example: "Alt+F:N" in a traditional "New..." menu item.
- The shortcut, if it exists, will invoke the same action without showing the component or its enclosing menus or dialogs. Example: "Ctrl+N" in a traditional "New..." menu item.

Example: For a traditional "New..." menu item, the expected return value would be: "N;Alt+F:N;Ctrl+N" for the English locale and "N;Alt+D:N;Strg+N" for the German locale. If, hypothetically, this menu item lacked a mnemonic, it would be represented by ";;Ctrl+N" and ";;Strg+N" respectively.

## getLocalizedName

actionGetLocalizedName Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Object` instance that implements AtkActionIface
-> Int32 | `i`: the action index corresponding to the action to be performed
-> m (Maybe Text) | Returns: a name string, or `Nothing` if `action` does not implement this interface.

Returns the localized name of the specified action of the object.

## getNActions

actionGetNActions Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Object` instance that implements AtkActionIface
-> m Int32 | Returns: a the number of actions, or 0 if `action` does not implement this interface.

Gets the number of accessible actions available on the object. If there are more than one, the first one is considered the "default" action of the object.

## getName

actionGetName Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Object` instance that implements AtkActionIface
-> Int32 | `i`: the action index corresponding to the action to be performed
-> m (Maybe Text) | Returns: a name string, or `Nothing` if `action` does not implement this interface.

Returns a non-localized string naming the specified action of the object. This name is generally not descriptive of the end result of the action, but instead names the 'interaction type' which the object supports. By convention, the above strings should be used to represent the actions which correspond to the common point-and-click interaction techniques of the same name: i.e. "click", "press", "release", "drag", "drop", "popup", etc. The "popup" action should be used to pop up a context menu for the object, if one exists.

For technical reasons, some toolkits cannot guarantee that the reported action is actually 'bound' to a nontrivial user event; i.e. the result of some actions via `actionDoAction` may be NIL.

## setDescription

actionSetDescription Source #

Arguments

:: (HasCallStack, MonadIO m, IsAction a) |
=> a | `action`: a `Object` instance that implements AtkActionIface
-> Int32 | `i`: the action index corresponding to the action to be performed
-> Text | `desc`: the description to be assigned to this action
-> m Bool | Returns: a gboolean representing if the description was successfully set;

Sets a description of the specified action of the object.